package xyz.veronie.bgg.result;

import java.util.ArrayList;
import java.util.List;

import xyz.veronie.bgg.result.internal.OutputResultHelper;

public class ThingDetails {
	Integer id;
	String name;
	String description;
	String image;
	String comment;

	Integer yearpublished;
	Integer minplayers;
	Integer maxplayers;

	List<IdString> designer;
	List<IdString> publisher;
	List<IdString> artist;

	List<IdString> category;
	List<IdString> mechanic;
	List<IdString> expansion;
	List<IdString> domain;
	List<IdString> family;
	

	Integer playingtime;
	Integer minplaytime;
	Integer maxplaytime;

	// poll suggested_numplayers
	List<Recommendation> players; // 1 to 20
	
	// poll suggested_playerage
	Float age_poll;
	
	Integer age;
	Integer usersrated;
	Integer average;
	Float bayesaverage;
	Integer rank;
	Integer rank_wg;
	Integer numcomments;
	Integer numweights;
	Float averageweight;
	Float stddev;
	Float median;

	Integer owning;
	Integer trading;
	Integer wanting;
	Integer wishing;
		


	//	Integer basegameId;
//	Integer reimplementId;
//	String reimplement_name;
//	Integer reimplementedById;
//	String reimplementedByName;
//	Integer containsId;
//	String containsName;
//	Integer iscontained;
//	String iscontained_name;
//	Integer integration;
//	String integration_name;
	Integer numplays;
	Float price;
	Integer expansions;
	
	public ThingDetails() {
		players = new ArrayList<Recommendation>();
		
		designer = new ArrayList<IdString>();
		publisher = new ArrayList<IdString>();
		artist = new ArrayList<IdString>();
		category = new ArrayList<IdString>();
		mechanic = new ArrayList<IdString>();
		expansion = new ArrayList<IdString>();
		domain = new ArrayList<IdString>();
		family = new ArrayList<IdString>();
	}
	
	public String toResultTextLine() {
		StringBuilder str = new StringBuilder();
		
		// designer,publisher,artist,yearpublished,minplayers,maxplayers,playingtime,minplaytime,maxplaytime,
        // age,usersrated,average,bayesaverage,rank,rank_wg,numcomments,numweights,averageweight,stddev,median,
		// category,mechanic,
		str.append(designer).append(",");
		str.append(publisher).append(",");
		str.append(artist).append(",");
		str.append(yearpublished).append(",");
		str.append(minplayers).append(",");
		str.append(maxplayers).append(",");
		str.append(playingtime).append(",");
		str.append(minplaytime).append(",");
		str.append(maxplaytime).append(",");
		str.append(age).append(",");
		str.append(usersrated).append(",");
		str.append(average).append(",");
		str.append(OutputResultHelper.floatToResult(bayesaverage)).append(",");
		str.append(rank).append(",");
		str.append(rank_wg).append(",");
		str.append(numcomments).append(",");
		str.append(numweights).append(",");
		str.append(OutputResultHelper.floatToResult(averageweight)).append(",");
		str.append(OutputResultHelper.floatToResult(stddev)).append(",");
		str.append(OutputResultHelper.floatToResult(median)).append(",");
		str.append(category).append(",");
		str.append(mechanic).append(",");

		// owned,trading,wanting,wishing
		str.append(owning).append(",");
		str.append(trading).append(",");
		str.append(wanting).append(",");
		str.append(wishing).append(",");

		// 1player,2player,3player,4player,5player,6player,7player,8player,9player,10player,
        // 11player,12player,13player,14player,15player,16player,17player,18player,19player,20player,
		for(Recommendation r : players) {
    		str.append(r.name()).append(",");
    	}

    	// description,exp,
		str.append(description).append(",");
		str.append(expansion).append(",");

		
		// basegame,reimplement,reimplement_name,reimplemented,reimplemented_name,
		// contains,contains_name,iscontained,iscontained_name,integration,integration_name,
//		str.append(basegameId).append(",");
//		str.append(reimplementId).append(",");
//		str.append(reimplement_name).append(",");
//		str.append(reimplementedById).append(",");
//		str.append(reimplementedByName).append(",");
//		str.append(containsId).append(",");
//		str.append(containsName).append(",");
//		str.append(iscontained).append(",");
//		str.append(iscontained_name).append(",");
//		str.append(integration).append(",");
//		str.append(integration_name).append(",");
		
		// price,expansions,domain,family,age_poll
		str.append(price).append(",");
		str.append(expansions).append(",");
		str.append(domain).append(",");
		str.append(family).append(",");
		str.append(age_poll);

		return str.toString();
	}

	public static String emptyReplacerLine() {
		return ",,,,,,,,,,,0.0,0.0,,,0,0,0.0,0.0,0.0,\"\",\"\",,,,,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,\"\",\"\",0.0,,\"\",\"\",0.0";
	}

	public static String resultHeader() {
		return "designer,publisher,artist,yearpublished,minplayers,maxplayers,playingtime,minplaytime,maxplaytime,age,usersrated,average,bayesaverage,rank,rank_wg,numcomments,numweights,averageweight,stddev,median,category,mechanic,1player,2player,3player,4player,5player,6player,7player,8player,9player,10player,11player,12player,13player,14player,15player,16player,17player,18player,19player,20player,description,exp,price,expansions,domain,family,age_poll";				
		// not doing: basegame,reimplement,reimplement_name,reimplemented,reimplemented_name,contains,contains_name,iscontained,iscontained_name,integration,integration_name,
	}


}
